﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TKTest {
    struct Cell {
        public int Val;

        public static int GetCType(int h,int reg) {
            if(reg<0) return -1;
            h=(h>>(4*reg))&7;
            if(h>=6) h=0;
            return h;
        }

        public static uint[] GenRandomCells() {
            int[] res=new int[1000];
            int pres=0;

            int[] s=new int[7];
            int[] v=new int[5];
            int[] dlog={1,8,8,4,4};
            int psum=0;
            for(int u=0;u<625*150;u++) {
                for(int i=0;i<5;i++) v[i]=0;
                int a=u;
                double plog=1.0/4;
                for(int i=0;i<6;i++) {
                    int b=a%5; a/=5;
                    s[i]=b;
                    v[b]++;
                    plog/=dlog[b];
                }
                s[6]=a;
                if(s[6]==5) plog/=8;
                if(v[0]==4){
                    if(v[3]==2 || v[4]==2) plog*=4;
                    else plog*=2;
                }
                if(v[0]==3) plog*=2;
                for(int i=1;i<5;i++) if(v[i]==1) plog/=1.5;
                int c=1;
                int a0=mperm(s,0);
                for(int i=1;i<24;i++) {
                    int a1=mperm(s,i);
                    if(a1==a0) c++;
                    if(a1<a0) goto _1;
                }
                plog*=24/c;
                if(v[3]!=0 && v[3]!=2 && s[6]!=1) continue;
                if(v[4]!=0 && v[4]!=2 && s[6]!=2) continue;
                if(v[1]>=5 && s[6]!=1) continue;
                if(v[2]>=5 && s[6]!=2) continue;
                if(opp(s,3) && s[6]!=1 && s[6]!=3) continue;
                if(opp(s,4) && s[6]!=2 && s[6]!=4) continue;
                if(s[6]==1 && (v[3]==0 || v[3]==2) && !opp(s,1)) continue;
                if(s[6]==2 && (v[4]==0 || v[4]==2) && !opp(s,2)) continue;
                if(s[6]==3 && (v[3]!=2 || !opp(s,3))) continue;
                if(s[6]==4 && (v[4]!=2 || !opp(s,4))) continue;
                int ilog=(int)Math.Round(Math.Log(plog,0.5));
                ilog=Math.Min(15,Math.Max(0,ilog));
                res[pres++]=a0+(ilog<<28);
                psum+=(0x8000>>ilog);
_1: ;
            }
            uint[] rres=new uint[pres];
            for(int i=0;i<pres;i++) rres[i]=(uint)res[i];
            return rres;
        }
        static int[,] perms={
            {0,1,2,3,4,5},{0,1,4,5,3,2},{2,3,4,5,0,1},{2,3,0,1,5,4},{4,5,0,1,2,3},{4,5,2,3,1,0},
        };
        static int[] perm2= { 0,0xf,0x33,0x3c };

        private static int mperm(int[] s,int a) {
            int b=s[6];
            for(int i=6;--i>=0;) {
                int j=perms[a/4,i];
                if(((1<<i)&perm2[a%4])!=0) j=j^1;
                b=(b<<4)|s[j];
            }
            return b;
        }

        private static bool opp(int[] s,int p) {
            if(s[0]==p && s[1]==p) return true;
            if(s[2]==p && s[3]==p) return true;
            if(s[4]==p && s[5]==p) return true;
            return false;
        }
    }
}
